(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["CKEditor5"] = factory();
	else
		root["CKEditor5"] = root["CKEditor5"] || {}, root["CKEditor5"]["ckeditorHeadingSize"] = factory();
})(self, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "ckeditor5/src/core.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/core.js");

/***/ }),

/***/ "ckeditor5/src/ui.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/ui.js");

/***/ }),

/***/ "ckeditor5/src/utils.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/utils.js");

/***/ }),

/***/ "ckeditor5/src/widget.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/widget.js");

/***/ }),

/***/ "dll-reference CKEditor5.dll":
/***/ ((module) => {

"use strict";
module.exports = CKEditor5.dll;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ src)
});

// EXTERNAL MODULE: delegated ./core.js from dll-reference CKEditor5.dll
var delegated_corefrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/core.js");
// EXTERNAL MODULE: delegated ./utils.js from dll-reference CKEditor5.dll
var delegated_utilsfrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/utils.js");
// EXTERNAL MODULE: delegated ./ui.js from dll-reference CKEditor5.dll
var delegated_uifrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/ui.js");
// EXTERNAL MODULE: delegated ./widget.js from dll-reference CKEditor5.dll
var delegated_widgetfrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/widget.js");
;// CONCATENATED MODULE: ./js/ckeditor5_plugins/ckeditorHeadingSize/src/headingsizeediting.js


class HeadingSizeEditing extends delegated_corefrom_dll_reference_CKEditor5.Plugin {

  static get pluginName() {
    return 'HeadingSizeEditing';
  }

  init() {
    const editor = this.editor;

    const headingOptions = editor.config.get( 'heading.options' );
    for(let option of headingOptions) {
      if (option.model.includes('heading')) {
        // Allow headings to have the fontSize attribute in their models.
        editor.model.schema.extend(option.model, {allowAttributes: 'fontSize'});

        // Convert from the view (the HTML) to the model.
        editor.conversion.for('upcast').attributeToAttribute({
          view: {
            name: option.view,
            classes: true,
          },
          model: {
            key: 'fontSize',
            value: (viewElement) => {
              return this.findHeadingSizeClassOnElement(viewElement);
            },
          },
          converterPriority: delegated_utilsfrom_dll_reference_CKEditor5.priorities.low + 1,
        });
      }
    }

    // Convert from the model to the view.
    editor.conversion.for('downcast').attributeToAttribute({
      model: 'fontSize',
      view: (attributeValue, conversionApi) => {
        return {
          key: 'class',
          value: attributeValue,
        };
      },
      converterPriority: delegated_utilsfrom_dll_reference_CKEditor5.priorities.low + 1,
    });
  }

  findHeadingSizeClassOnElement(element) {
    // Determine if the headings have any heading-size-14px classes.
    const headingClasses = Object.values(this.editor.config.get( 'headingSizes' ));
    for (let className of element.getClassNames()) {
      if (headingClasses.includes(className)) {
        return className;
      }
    }
  }

}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/ckeditorHeadingSize/src/headingsizeui.js






class HeadingSizeUI extends delegated_corefrom_dll_reference_CKEditor5.Plugin {

  static get pluginName() {
    return 'HeadingSizeUI';
  }

  static get requires() {
    return [ HeadingSizeEditing ];
  }

  afterInit() {
    const editor = this.editor
    const headingUi = editor.plugins.get('HeadingUI');
    if (headingUi.isEnabled) {
      // Listen for clicks in the editor.
      this.listenTo( editor.editing.view.document, 'click', () => {
        // Determine if the click was on a heading tag.
        const parentHeading = this.getSelectedHeadingElement();
        if ( parentHeading ) {
          // Build a contextual menu.
          this._balloon = editor.plugins.get( delegated_uifrom_dll_reference_CKEditor5.ContextualBalloon );
          // With a select list of font sizes to choose from.
          this.dropdownLabeledFieldView = new delegated_uifrom_dll_reference_CKEditor5.LabeledFieldView(editor.locale, delegated_uifrom_dll_reference_CKEditor5.createLabeledDropdown);
          // Set the label.
          const editing = editor.plugins.get(HeadingSizeEditing)
          const className = editing.findHeadingSizeClassOnElement(parentHeading);
          const headingSizes = this.editor.config.get( 'headingSizes' );
          const label = className ? Object.keys(headingSizes).find(key => headingSizes[key] === className) : Drupal.t('Font Size');
          this.dropdownLabeledFieldView.set({
            label: label,
            'class': 'black-label',
          });
          this.dropdownLabeledFieldView.fieldView.buttonView.set({
            withText: true,
          })

          // Add font size options.
          let items = new delegated_utilsfrom_dll_reference_CKEditor5.Collection();
          for(let option in headingSizes) {
            items.add({
              type: 'button',
              model: new delegated_uifrom_dll_reference_CKEditor5.Model({
                id: headingSizes[option],
                label: option,
                withText: true,
              })
            });
          }
          (0,delegated_uifrom_dll_reference_CKEditor5.addListToDropdown)(this.dropdownLabeledFieldView.fieldView, items);

          // Add the contextual balloon.
          this._balloon.add({
            view: this.dropdownLabeledFieldView,
            position: this.getBalloonPositionData(),
          });

          // Close the context balloon if the user clicks outside of it.
          (0,delegated_uifrom_dll_reference_CKEditor5.clickOutsideHandler)({
            emitter: this.dropdownLabeledFieldView,
            activator: () => this._balloon.hasView( this.dropdownLabeledFieldView ),
            contextElements: [ this._balloon.view.element ],
            callback: () => this.hideUI()
          });

          // A font size option was clicked.
          this.dropdownLabeledFieldView.fieldView.on('execute', (event) => {
            let value = event.source.label;

            // Set the dropdown label.
            this.dropdownLabeledFieldView.label = value;
            // Add the font size to the heading model.
            this.editor.model.change((writer) => {
              const blocks = Array.from( this.editor.model.document.selection.getSelectedBlocks() );
              const headingSizes = this.editor.config.get( 'headingSizes' );
              for ( const block of blocks ) {
                writer.setAttribute('fontSize', headingSizes[value], block);
              }
            });
          });
        }
      });
    }
  }

  getSelectedHeadingElement() {
    const view = this.editor.editing.view;
    const selection = view.document.selection;
    const selectedElement = selection.getSelectedElement();

    // The selection is collapsed or some widget is selected (especially inline widget).
    if ( selection.isCollapsed || selectedElement && (0,delegated_widgetfrom_dll_reference_CKEditor5.isWidget)( selectedElement ) ) {
      return this.findHeadingElementAncestor( selection.getFirstPosition());
    }  else {
      // The range for fully selected heading is usually anchored in adjacent text nodes.
      // Trim it to get closer to the actual heading element.
      const range = selection.getFirstRange().getTrimmed();
      const startHeading = this.findHeadingElementAncestor( range.start );
      const endHeading = this.findHeadingElementAncestor( range.end );

      if ( !startHeading || startHeading != endHeading ) {
        return null;
      }

      // Check if the heading element is fully selected.
      if ( view.createRangeIn( startHeading ).getTrimmed().isEqual( range ) ) {
        return startHeading;
      } else {
        return null;
      }
    }
  }

  getBalloonPositionData() {
    const view = this.editor.editing.view;
    const viewDocument = view.document;
    let target = null;

    // Set a target position by converting view selection range to DOM.
    target = () => view.domConverter.viewRangeToDom(
      viewDocument.selection.getFirstRange()
    );

    return {
      target
    };
  }

  findHeadingElementAncestor( position) {
    return position.getAncestors().find( ( ancestor ) => this.isHeadingElement( ancestor ) ) || null;
  }

  hideUI() {
    // Make sure the focus always gets back to the editable _before_ removing the focused form view.
    // Doing otherwise causes issues in some browsers. See https://github.com/ckeditor/ckeditor5-link/issues/193.
    this.editor.editing.view.focus();
    this._balloon.remove( this.dropdownLabeledFieldView);
  }

  isHeadingElement( node) {
    const headingOptions = this.editor.config.get( 'heading.options' );
    let headings = [];
    for(let option of headingOptions) {
      if (option.model.includes('heading')) {
        headings.push(option.view);
      }
    }
    return headings.includes(node.name);
  }

}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/ckeditorHeadingSize/src/headingsize.js




class HeadingSize extends delegated_corefrom_dll_reference_CKEditor5.Plugin {

  static get requires() {
    return [ HeadingSizeUI, HeadingSizeEditing ];
  }

  static get pluginName() {
    return 'HeadingSize';
  }
}


;// CONCATENATED MODULE: ./js/ckeditor5_plugins/ckeditorHeadingSize/src/index.js

/* harmony default export */ const src = ({
  HeadingSize: HeadingSize,
});

})();

__webpack_exports__ = __webpack_exports__["default"];
/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=ckeditorHeadingSize.js.map